// Copyright (c) 2007-2010 Sonic Foundry, Inc. and Sonic Foundry 
// Media Systems, Inc. Neither this code nor any portion 
// thereof may be reproduced, altered, or otherwise changed, 
// distributed or copied, without the express written 
// permission of Sonic Foundry.
// All rights reserved.

Manifest = function(){}

Slide = function(text,time,description)
{
	this.Text=text;
	this.Time=time;
	this.Description=description;
}
Chapter = function(text,time)
{
	this.Text=text;
	this.Time=time;
}
SupportingLink = function(description,url)
{
	this.Description=description;
	this.Url=url;
}
Presenter = function(name, imageUrl, email, bioUrl)
{
    this.Name = name;
    this.ImageUrl = imageUrl;
    this.Email = email;
    this.BioUrl = bioUrl;
}

Manifest.OnLoad=function()
{
    Manifest.LoadPresenters();   
    Manifest.LoadSlides();
    Manifest.LoadChapters();
    Manifest.LoadSupportingLinks();    
    
    return true;
}

Manifest.GetSlideUrl = function(slideNumber, width, height)
{
    var slideFileName = String.format(Manifest.SlideImageFileNameTemplate, slideNumber);

    if (arguments.length == 3 && !Manifest.IsStandAlone)
    {
        slideFileName = slideFileName.replace(/full/i, String.format("{0}_{1}", width, height));
    }

    var source = String.format("{0}{1}", Manifest.SlideBaseUrl, slideFileName);

    if ((Manifest.AnonymousAllowed == null || Manifest.AnonymousAllowed == false) && (Manifest.SlidePlaybackTicketId != null && Manifest.SlidePlaybackTicketId.length > 0))
    {
        if (source.indexOf('?') > -1)
        {
            source += '&playbackTicket=' + Manifest.SlidePlaybackTicketId;
        }
        else
        {
            source += '?playbackTicket=' + Manifest.SlidePlaybackTicketId;
        }
    }

    return source;
}

Manifest.GetSlideTime=function(slideNumber)
{
    return Manifest.Slides[slideNumber].Time;
}
Manifest.GetSlideTitle=function(slideNumber)
{
    return Manifest.Slides[slideNumber-1].Text;
}
Manifest.GetSlideDescription=function(slideNumber)
{
    return Manifest.Slides[slideNumber-1].Description;
}


Manifest.Version="5.5.6081";
Manifest.IsStandAlone=true;
Manifest.VideoUrl="Content/c084fd8a-e364-4c26-9137-ad421ffa402f.wmv";
Manifest.SlideBaseUrl="Content/";
Manifest.PlaybackTicketId="";
Manifest.SlidePlaybackTicketId="";
Manifest.IsLive=false;
Manifest.IsOnDemand=true;
Manifest.PlayStatus="OnDemand";
Manifest.PollingEnabled=false;
Manifest.ForumEnabled=false;
Manifest.PresentationThumbImage="";
Manifest.HasSlides=true;
Manifest.HasVideo=true;
Manifest.AnonymousAllowed=true;
Manifest.SlideImageFileNameTemplate="slide_{0:D4}_full.jpg";
Manifest.PresentationId="c084fd8ae3644c269137ad421ffa402f1d";
Manifest.Title="Green Chemistry: Composites project using styrene-free resin";
Manifest.Description="MPCA will host a workshop to share findings from recent green chemistry work with composites. Dr. Laura Babcock, Director of the Minnesota Technical Assistance Program, will be the lead speaker and will discuss the use of styrene-free resin in pilots conducted at Minnesota fiber reinforced plastic manufacturing facilities.";
Manifest.Duration=3664409;
Manifest.AirDate="11/9/2012";
Manifest.AirTime="9:30 AM CST";
Manifest.CaptionsFile="";
Manifest.LoadSlides=function(){
Manifest.Slides = new Array(48);
   Manifest.Slides[0] = new Slide("",1614,"");
   Manifest.Slides[1] = new Slide("",177575,"");
   Manifest.Slides[2] = new Slide("",212922,"");
   Manifest.Slides[3] = new Slide("",311751,"");
   Manifest.Slides[4] = new Slide("",371635,"");
   Manifest.Slides[5] = new Slide("",390915,"");
   Manifest.Slides[6] = new Slide("",407070,"");
   Manifest.Slides[7] = new Slide("",442389,"");
   Manifest.Slides[8] = new Slide("",531170,"");
   Manifest.Slides[9] = new Slide("",632516,"");
   Manifest.Slides[10] = new Slide("",784732,"");
   Manifest.Slides[11] = new Slide("",798694,"");
   Manifest.Slides[12] = new Slide("",822603,"");
   Manifest.Slides[13] = new Slide("",889152,"");
   Manifest.Slides[14] = new Slide("",994150,"");
   Manifest.Slides[15] = new Slide("",1074650,"");
   Manifest.Slides[16] = new Slide("",1083998,"");
   Manifest.Slides[17] = new Slide("",1142171,"");
   Manifest.Slides[18] = new Slide("",1161387,"");
   Manifest.Slides[19] = new Slide("",1237211,"");
   Manifest.Slides[20] = new Slide("",1239293,"");
   Manifest.Slides[21] = new Slide("",1259041,"");
   Manifest.Slides[22] = new Slide("",1286651,"");
   Manifest.Slides[23] = new Slide("",1315780,"");
   Manifest.Slides[24] = new Slide("",1430050,"");
   Manifest.Slides[25] = new Slide("",1530260,"");
   Manifest.Slides[26] = new Slide("",1650182,"");
   Manifest.Slides[27] = new Slide("",1792416,"");
   Manifest.Slides[28] = new Slide("",1878233,"");
   Manifest.Slides[29] = new Slide("",2004453,"");
   Manifest.Slides[30] = new Slide("",2033579,"");
   Manifest.Slides[31] = new Slide("",2105173,"");
   Manifest.Slides[32] = new Slide("",2132113,"");
   Manifest.Slides[33] = new Slide("",2173112,"");
   Manifest.Slides[34] = new Slide("",2312747,"");
   Manifest.Slides[35] = new Slide("",2395841,"");
   Manifest.Slides[36] = new Slide("",2499275,"");
   Manifest.Slides[37] = new Slide("",2529405,"");
   Manifest.Slides[38] = new Slide("",2545528,"");
   Manifest.Slides[39] = new Slide("",2572997,"");
   Manifest.Slides[40] = new Slide("",2591734,"");
   Manifest.Slides[41] = new Slide("",2635413,"");
   Manifest.Slides[42] = new Slide("",2698337,"");
   Manifest.Slides[43] = new Slide("",2724910,"");
   Manifest.Slides[44] = new Slide("",2810088,"");
   Manifest.Slides[45] = new Slide("",2910260,"");
   Manifest.Slides[46] = new Slide("",2999149,"");
   Manifest.Slides[47] = new Slide("",3054156,"");
};
Manifest.HasSlideDescriptions=false;
Manifest.LoadChapters=function(){
Manifest.Chapters = new Array(0);
};
Manifest.LoadSupportingLinks=function(){
Manifest.SupportingLinks = new Array(1);
   Manifest.SupportingLinks[0] = new SupportingLink("MPCA Green Chemistry","http://www.pca.state.mn.us/greenchemistry");
};
Manifest.LoadPresenters=function(){
Manifest.Presenters = new Array(1);
   Manifest.Presenters[0] = new Presenter("MPCA Staff","","","");
};
